<?php
namespace  QuiversBopis\Integration\Controller\Store;

use  QuiversBopis\Integration\Model\ConfigProvider;

class Add extends \Magento\Framework\App\Action\Action
{
	 /**
     * @var \Magento\Framework\Controller\Result\JsonFactory
     */
	const XML_QUIVERS_UPC = 'quivers/parameters/quivers_custom_upc';
    protected $resultJsonFactory;
	protected $request;
	protected $formKey;  
	protected $cart;
	protected $product;
	protected $cartSession;
	protected $quote;
	protected $configProvider;
    /**
     * @param \Magento\Framework\App\Action\Context $context
     * @param \Magento\Framework\Controller\Result\JsonFactory $resultJsonFactory
     */
    public function __construct(
       \Magento\Framework\App\Action\Context $context,
	   \Magento\Framework\App\RequestInterface $request,
	   \Magento\Framework\Data\Form\FormKey $formKey,
	   \Magento\Checkout\Model\Session $checkoutSession,
	   \Magento\Checkout\Model\Cart $cart,
	   ConfigProvider $configProvider,
	   \Magento\Catalog\Model\ProductRepository $product,
       \Magento\Framework\Controller\Result\JsonFactory $resultJsonFactory,
	   array $data = [])
	{
		$this->resultJsonFactory = $resultJsonFactory;
		$this->formKey = $formKey;
		$this->quote = $checkoutSession->getQuote();
		$this->cart = $cart;
		$this->configProvider = $configProvider;
		$this->product = $product; 
		$this->request =$request;
		parent::__construct($context);
	}

	public function execute()
	{
		//add store in volatile memory and in session.
		$resultJson = $this->resultJsonFactory->create();     
		$objectManager = \Magento\Framework\App\ObjectManager::getInstance();
		$request = $objectManager->get('Magento\Framework\App\RequestInterface');
		$checkoutSession = $objectManager->get('Magento\Checkout\Model\Session');
		$reqData = $request->getParams();
		$storename =null;
		$message =null;
		$items = $this->quote->getAllItems();
		if(isset($reqData['store'])) {
			$store = json_decode($reqData['store'], true);
			$address = $store['address'];
			$storeids=[];
			$searchterm =[] ;

		}

		try {
			foreach($items as $item) {
				$itemData = $item->getData();
				if(array_key_exists('parent_item_id', $itemData) 
						&& $itemData['parent_item_id'] != null) {
					continue;
				}

				$AdditionalData =$item->getBopisdata();
				$AdditionalData=json_decode($AdditionalData);
				$itemupc = $this->configProvider->getUPC($item);
				$searchterm =[$item->getsku(),$itemupc];
				if(in_array($reqData['searchTerm'], $searchterm)){
					$cartItems = [
						'uuid'=>$AdditionalData->uuid,
						'id'=>$AdditionalData->id,
						'sku'=>$AdditionalData->sku,
						'businessRefId'=> isset($store['businessRefId']) && $store['businessRefId']!=null? $store['businessRefId']:null,
						'searchterm'=>isset($reqData['searchTerm'])?$reqData['searchTerm']:null,
						'userlocation'=>isset($reqData['userPostalcode'])?$reqData['userPostalcode'] :null,
						'businessName' =>isset($store['businessRefId']) && $store['businessName']?$store['businessName']:null, 
						'city' => isset($store['businessRefId']) && $address['city']?$address['city']:null, 
						'storepostalcode' => isset($store['businessRefId']) && $address['postalCode']?$address['postalCode']:null,
						'state' =>isset($store['businessRefId']) &&  $address['region']['abbreviation']?$address['region']['abbreviation']:null,
						'country' => isset($store['businessRefId']) && $address['country']['abbreviations']['two']?$address['country']['abbreviations']['two']:null, 
						'curbsidepick' =>isset($store['businessRefId']) &&  $reqData['shipping'] == 2 ? true : false, 
						'instorepickup' => isset($store['businessRefId']) && $reqData['shipping'] == 1 ? true : false,
						'bopis_item' => isset($store['item']) && $store['item']!=null? $store['item']:null

					];
					$storeId = isset($AdditionalData->businessRefId)?$AdditionalData->businessRefId:null;

					$item->setBopisdata(json_encode($cartItems));

					if(isset($AdditionalData->businessRefId)){
						$method= $_SESSION['quivers_shipping_rate'];
					
						$item->setBopisShippingcode($method['label']);
						$item->setBopisShippingfee($method['price']);
					}
					$item->save();
					
					$response = ['success' => 'true','redirect'=>true];
				}
		
			}  
			$this->configProvider->getShippingCarrier($storeId);
			return $resultJson->setData($response); 
		} catch (\Exception $e) {
			$this->messageManager->addErrorMessage($e->getMessage());
		}

	}
}
