<?php
namespace  QuiversBopis\Integration\Controller\Shipping;

use  QuiversBopis\Integration\Model\ConfigProvider;

class Methods extends \Magento\Framework\App\Action\Action
{
	 /**
     * @var \Magento\Framework\Controller\Result\JsonFactory
     */
	const XML_QUIVERS_UPC = 'quivers/parameters/quivers_custom_upc';
    protected $resultJsonFactory;
	protected $request;
	protected $formKey;  
	protected $cart;
	protected $product;
	protected $cartSession;
	protected $quote;
	protected $configProvider;
	protected $addressRepository;

    /**
     * @param \Magento\Framework\App\Action\Context $context
     * @param \Magento\Framework\Controller\Result\JsonFactory $resultJsonFactory
     */
    public function __construct(
       \Magento\Framework\App\Action\Context $context,
	   \Magento\Framework\App\RequestInterface $request,
	   \Magento\Framework\Data\Form\FormKey $formKey,
	   \Magento\Checkout\Model\Session $checkoutSession,
	   \Magento\Checkout\Model\Cart $cart,
	   ConfigProvider $configProvider,
	   \Magento\Customer\Api\AddressRepositoryInterface $addressRepository,
	   \Magento\Catalog\Model\ProductRepository $product,
       \Magento\Framework\Controller\Result\JsonFactory $resultJsonFactory,
	   array $data = [])
	{
		$this->resultJsonFactory = $resultJsonFactory;
		$this->formKey = $formKey;
		$this->quote = $checkoutSession->getQuote();
		$this->cart = $cart;
		$this->configProvider = $configProvider;
		$this->product = $product; 
		$this->request =$request;
		$this->addressRepository = $addressRepository;
		parent::__construct($context);
	}

	public function execute()
	{
		$objectManager = \Magento\Framework\App\ObjectManager::getInstance();
		$checkoutSession = $objectManager->get('Magento\Checkout\Model\Session');
		//add store in volatile memory and in session.
	    $resultJson = $this->resultJsonFactory->create();     
		$items = $this->quote->getAllItems();
		$reqData = $this->request->getParams();
        try{
			foreach ($items as $item)
			{				
				$itemData = $item->getData();
				if(array_key_exists('parent_item_id', $itemData) 
						&& $itemData['parent_item_id'] != null) {
					continue;
				}

				$AdditionalData =$item->getBopisdata();
				$bopisdata = json_decode($AdditionalData);
                if (isset($bopisdata->curbsidepick) && $bopisdata->curbsidepick==false  && isset($bopisdata->instorepickup) && $bopisdata->instorepickup==false && isset($reqData['shippingcode']) && isset($reqData['price']))
                {
					$item->setBopisShippingcode($reqData['title']);
					$item->setBopisShippingfee($reqData['price']);
					$_SESSION['quivers_shipping_rate'] =json_decode(json_decode($reqData['selectedmethod'],true),true);
					$item->save();					
                }
				
			}
		
		} catch (\Exception $e) {
				$this->messageManager->addErrorMessage($e->getMessage());
		}

	}
}
