<?php
namespace QuiversBopis\Integration;

use \Magento\Framework\HTTP\Client\Curl as CurlClient;
use Magento\Shipping\Model\Config;

class LogTracking
{

	protected $logEndpoint = 'logs/';
	protected $curlClient;
	protected $scopeConfig;
    public $configProvider;
	
	const XML_QUIVERS_API_KEY = 'quivers/parameters/quivers_api_key';
    const XML_QUIVERS_BOPIS_SANDBOX_STATUS='quiversbopis/parameters/quiversbopis_sandbox';

	public function __construct()
    {
        $this->curlClient = new CurlClient();
        $this->scopeConfig = \Magento\Framework\App\ObjectManager::getInstance()->get(\Magento\Framework\App\Config\ScopeConfigInterface::class);
    }

    public function cartData($items){
        $logData = [
            "cartdata" => $items
        ];
         $this->logging("BOPIS CART ITEMS", $items);
    }

    public function orderGenerate($url, $data, $header){
        $logData = [
            "url" => $url,
            "data" => $data,
            "header"=> $header
        ];
        $this->logging("BOPIS ORDER GENERATE", $logData);
    }

    public function orderGenerateSuccess($url, $data, $header, $response){
        $logData = [
            "url" => $url,
            "data" => $data,
            "header"=> $header,
            "response"=>$response
        ];
        $this->logging("BOPIS ORDER GENERATE SUCCESS", $logData);
    }


   	public function logging($type, $data)
    {
        $storeScope = \Magento\Store\Model\ScopeInterface::SCOPE_STORE;
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $configProvider = $objectManager->get("\QuiversBopis\Integration\Model\ConfigProvider");
        $quiversSandbox = $this->scopeConfig->getValue(self::XML_QUIVERS_BOPIS_SANDBOX_STATUS, $storeScope);
        $quiversAPIKey =$this->scopeConfig->getValue("quivers/parameters/quivers_api_key", $storeScope);
        $baseUrl = 'https://middleware.quiversdemo.com/profile/';
        if($quiversSandbox == 0) {
            $baseUrl = 'https://middleware.quivers.com/profile/';
        }

    	$logdata = [
    		"api_key" => "apiKey ".$quiversAPIKey,
            "type" => $type,
    		"log_data" => $data,
            "uuid" => uniqid(),
    	];
    	$logUrl = $baseUrl.$this->logEndpoint;  

        $this->curlClient->post($logUrl, json_encode($logdata));
    }
}