<?php 

namespace QuiversBopis\Integration\Model;

/**
 * ConfigProvider Class
 */
class ConfigProvider
{
        
	const CODE = 'quivers_integration';
    const COUNTRY_CODE_PATH = 'general/country/default';
	const PATH = 'ecommerce';
    const MODE = 'TEST';
    const XML_QUIVERS_quiversdemo = 'quivers/parameters/quivers_custom_quiversdemo';
    const XML_QUIVERS_API_KEY = 'quivers/parameters/quivers_api_key';
    const XML_QUIVERS_REF_ID = 'quivers/parameters/merchant_ref_id';
    const XML_MARKETPLACE_ID = 'quivers/parameters/marketplaceId';
    const XML_QUIVERS_SANDBOX = 'quivers/parameters/quivers_sanndbox';
    const XML_USD_MARKETPLACE_ID = 'quivers_tax/marketplaces/usdMarketPlaceId';
    const XML_EURO_MARKETPLACE_ID = 'quivers_tax/marketplaces/euroMarketPlaceId';
    const XML_CAD_MARKETPLACE_ID = 'quivers_tax/marketplaces/cadMarketPlaceId';
    const XML_AUD_MARKETPLACE_ID ='quivers_tax/marketplaces/audMarketPlaceId';
    const XML_JPY_MARKETPLACE_ID = 'quivers_tax/marketplaces/jpyMarketPlaceId';
    const XML_GBP_MARKETPLACE_ID = 'quivers_tax/marketplaces/gbpMarketPlaceId';    
    const XML_ENABLED = 'quiversbopis/parameters/enable';
    const XML_QUIVERS_UPC = 'quivers/parameters/quivers_custom_upc';
    const XML_QUIVERS_BOPIS_SANDBOX_STATUS='quiversbopis/parameters/quiversbopis_sandbox';

    protected $scopeConfig;
	protected $_storeManager;
    public $ccConfig;
	protected $_currency;
    protected $getshippingmodel;
    public $storepickupcode ="bopispickup";
    public $bopismixed ="bopismixed";
    public $errormessagedefault ='Please reload the page and try again. If the issue persists please contact Quivers at 805-250-4555';
    public $bopisStatusCode =1;
    public $shippingSatusCode =0;
    public $mixedStatusCode =2;
    public $i=0;

	public function __construct(
	    \Magento\Payment\Model\CcConfig $ccConfig,
	    \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
		\Magento\Store\Model\StoreManagerInterface $storeManager,
        // \Magento\Directory\Model\Currency $currency, 
	    array $methodCodes = []
	) {
        $this->ccConfig =$ccConfig;
	    $this->scopeConfig = $scopeConfig;
		$this->_storeManager = $storeManager;
        // $this->_currency = $currency;   
		$storeScope = \Magento\Store\Model\ScopeInterface::SCOPE_STORE;
	}

	public function getBopisStatus()
	{	
		$storeScope = \Magento\Store\Model\ScopeInterface::SCOPE_STORE;
        return  $this->scopeConfig->getValue(self::XML_ENABLED, $storeScope);
    }

	public function getBopisSandboxStatus()
	{	
		$storeScope = \Magento\Store\Model\ScopeInterface::SCOPE_STORE;
        return $this->scopeConfig->getValue(self::XML_QUIVERS_BOPIS_SANDBOX_STATUS, $storeScope);
	
    }

	public function getCurrency() {
		$objectManager = \Magento\Framework\App\ObjectManager::getInstance();
		$cart = $objectManager->get('\Magento\Checkout\Model\Cart'); 
		$quote = $cart->getQuote(); 
		return 	$quote->getQuoteCurrencyCode();
	}

    public function getHosotedJsPath() {
        if($this->getBopisSandboxStatus()==0) {
            return 'https://d37gifaus44yor.cloudfront.net/bopishosted.js';
		}else 
		{
            return 'https://d37gifaus44yor.cloudfront.net/bopishosted.js';
		}
	}

	/**
     * Get current store currency code
     *
     * @return string
     */
    public function getCurrentCurrencyCode()
    {
        return $this->_storeManager->getStore()->getCurrentCurrencyCode();
    }  

    public function getShippingMethods() {
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $getshippingmodel = $objectManager->get(\QuiversBopis\Integration\Model\GetShippingMethod::class);
        $storeid =null;
        return $getshippingmodel->getShippingMethods($storeid);    
    }
    /**
     * Get current store currency code
     *
     * @return string
     */
    public function getCurrentCurrencySymbol()
    {
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $currency = $objectManager->create('Magento\Directory\Model\CurrencyFactory')->create()->load($this->getCurrentCurrencyCode()); 
        return $currency->getCurrencySymbol();
    }  

	public function getSiteMode()
	{	
		return self::MODE;
    }


    public function getShippingCarrier($storeid){
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $checkoutSession = $objectManager->get('Magento\Checkout\Model\Session');
        $addressRateFactory = $objectManager->get("\Magento\Quote\Model\Quote\Address\RateFactory");
        $bopistatus =$this->getBopisStatus();
        $checkoutSession->setQuiversBopisStoreid($storeid);
        $shipping_address = $checkoutSession->getQuote()->getShippingAddress();
        $final_methods = [];
        // $shipping_address->requestShippingRates();
        $found = $shipping_address->requestShippingRates();
        $result = $checkoutSession->getQuiversShippingRates();
        $this->setShippingWithQuoteItems();
        return $result;
    }
    public function getActiveCarriers(){
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $shipconfig = $objectManager->get('\Magento\Shipping\Model\Config');
        $shippingRates = $shipconfig->getActiveCarriers();
        usort($shippingRates, function($a, $b) {return strcmp($a->getCarrierCode(), $b->getCarrierCode());});
        $shippingRates =  array_reverse($shippingRates);
      
        return $shippingRates;
    }

	public function getApiBaseUrl()
	{	
		if($this->getBopisSandboxStatus()==0) {
            return 'https://api.quivers.com/';
		}else 
		{
            return 'https://api.quiversdemo.com/';
		}
    }

    public function setShippingWithQuoteItems($updatequote = false){
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $checkoutSession = $objectManager->get('Magento\Checkout\Model\Session');
        $bopistatus =$this->getBopisStatus();
        if(!$bopistatus){
            $checkoutSession->setQuiversShippingStatus($this->shippingSatusCode);
            $_SESSION['shipping'] = $this->shippingSatusCode;
            return ['shippingcost'=>0,'title'=>null];
        }

        $checkoutSession->setQuiversShippingStatus($this->shippingSatusCode);
        $methods = [];
        $all_methods = [];
        if($checkoutSession->getAllShippingRates()!=[]){
            $all_methods=$checkoutSession->getAllShippingRates();
        }
        if(isset($_SESSION['quivers_shipping_rate']) && $_SESSION['quivers_shipping_rate']!=[]){
            $methods = $_SESSION['quivers_shipping_rate'];

        }else{
            foreach($all_methods as $key=>$all_method){
                if($this->storepickupcode==$all_method['code'] && $this->bopismixed==$all_method['code']){
                    $methods = $all_methods[$key];
                    $_SESSION['quivers_shipping_rate']=$methods;
                }
            }
        }
        $Session = $objectManager->get(\Magento\Checkout\Model\Session::class);
        $quote=  $Session->getQuote();
        $items = $quote->getAllItems();
        $shipped_qty = 0;
        $shipped_code ="";
        foreach ($items as $_item)
        {   
            $itemData = $_item->getData();
            if(array_key_exists('parent_item_id', $itemData) 
                    && $itemData['parent_item_id'] != null) {
                continue;
            }
            $AdditionalData =$_item->getBopisdata();
            $AdditionalData=json_decode($AdditionalData);
            if(!isset($AdditionalData->businessRefId)){
                $shipped_qty =  $shipped_qty+1;
                if( $_item->getBopisShippingcode() && $shipped_code ==""){
                    $shipped_code =  $_item->getBopisShippingcode();
                }    
            }
        }
        $totalShipamount = 0;
        if($shipped_code){
            foreach($all_methods as $all_method){
                if ($shipped_code == $all_method['label']){
                    $totalShipamount = (float)$all_method['price'];
                }
            }
        }
        else{
            if(isset($methods['code'])){
                $totalShipamount = (float)$methods['price'];
            }
        }

        //split shipping amount at line item level
        $approx_ship_amounts = [];
        if ($shipped_qty>0){
            $approx_ship_amounts = $this->splitShippingLineItem($totalShipamount, $shipped_qty);
        }

        $title = [];
        $titledisplay =null;
        $shippingCost =0;
        $index = 0;
        $shipping = 0;
        $instore = 0;
        foreach ($items as $_item)
        {

            $itemData = $_item->getData();
            if(array_key_exists('parent_item_id', $itemData) 
                    && $itemData['parent_item_id'] != null) {
                continue;
            }

            $shiplabel ='';
            $lineItemlevelfee = 0;

            $AdditionalData =$_item->getBopisdata();
            $AdditionalData=json_decode($AdditionalData);

            if(isset($AdditionalData->businessRefId)){
                //Bopis Quote Item
                $instore =1;
                foreach($all_methods as $all_method){
                    if($this->storepickupcode==$all_method['code']){
                            $shiplabel  = $all_method['label'];
                            $_item->setBopisShippingcode($shiplabel);
                            $_item->setBopisShippingfee(0);
                    }
                }
                if(!in_array($shiplabel,$title)){
                    array_push($title,$shiplabel);
                    $shippingCost =(float)$shippingCost+(float)0;
                } 
            }
            else {
                //Shipping Quote Item
                $shipping =1;
                if($_item->getBopisShippingcode()!=null){ 

                    //Shipping is already assigned to item
                    $lineItemlevelfee = (float)$approx_ship_amounts[$index];
                    $shiplabel = $_item->getBopisShippingcode();
                    $_item->setBopisShippingcode($shiplabel);
                    $_item->setBopisShippingfee((float)$lineItemlevelfee);
                    if(!in_array($shiplabel,$title)){
                        array_push($title,$shiplabel);
                    }
                    $shippingCost =(float)$shippingCost+(float)$lineItemlevelfee;
                }else{
                    // Shipping is not assigned to item
                    if ($shipped_code != ''){
                        foreach($all_methods as $all_method){
                            if ($shipped_code == $all_method['label']){
                                $shiplabel  = $all_method['label'];
                                $_item->setBopisShippingcode($all_method['label']);
                            }
                        }
                        $lineItemlevelfee = (float)$approx_ship_amounts[$index];
                        $_item->setBopisShippingfee($lineItemlevelfee);
                        if(!in_array($shiplabel,$title)){
                            array_push($title, $shiplabel);
                        } 
                        $shippingCost =(float)$shippingCost+(float)$lineItemlevelfee;    
                    }
                    elseif(isset($methods['code'])){
                        $lineItemlevelfee = (float)$approx_ship_amounts[$index];
                        $shiplabel  = $methods['label'];
                        $_item->setBopisShippingcode($shiplabel);
                        $_item->setBopisShippingfee((float)$lineItemlevelfee);
                        if(!in_array($shiplabel,$title)){
                            array_push($title, $shiplabel);
                        }  
                        $shippingCost =(float)$shippingCost+(float)$lineItemlevelfee;   
                    }
                }
                $index = $index +1;
            }
            if($updatequote){
                $_item->save();
            }

        }
        if($title!=null){
            $titledisplay =implode(",",$title);
        }
        if($shipping==1 && $instore==1 ){
            $checkoutSession->setQuiversShippingStatus($this->mixedStatusCode);
        }else if($shipping==0 && $instore==1){
            $checkoutSession->setQuiversShippingStatus($this->bopisStatusCode);
        }
        
        $data = ['shippingcost'=>$shippingCost,'title'=>$titledisplay];
        $checkoutSession->setQuiversBopisShippingData($data);
        return ['shippingcost'=>$shippingCost,'title'=>$titledisplay];
   
    }

    
    public function splitShippingLineItem($amount, $item_count){
        # divide shipping by item_count, truncate it to 2 decimal places
        $amount= (float)$amount;
        $item_count = (int)$item_count;
        $apprx_per_item_amount = (float)$amount/$item_count;
        $apprx_per_item_str = floatval(substr($apprx_per_item_amount, 0, strpos($apprx_per_item_amount, '.') + 3));
        
        # as we are truncating, difference woud always be +ve and needs to be added
        # also this won't be greater than 0.01 times the item count
        $positive_diff = round($amount - ((float)$apprx_per_item_str*$item_count),2);
        $approx_ship_amounts = [];
        for ($x = 1; $x <= $item_count; $x++) {
            array_push($approx_ship_amounts, $apprx_per_item_str);
        }
        
        # add 0.01 of the positive_diff in each approx_ship_amount until it reduces to 0
        $idx = 0;
        while($positive_diff > 0) {
            $approx_ship_amounts[$idx] = (string)(round((float)$approx_ship_amounts[$idx] + 0.01,2));
            $positive_diff = $positive_diff-0.01;
            $idx = $idx + 1;        
        }
        return $approx_ship_amounts;  
    
    }


	public function getBuisinessRefId()
	{	
		if($this->getBopisSandboxStatus()==0) {
            return 'https://api.quivers.com/';
		}else 
		{
            return 'https://api.quiversdemo.com/';
		}
    }

	public function getUPC($product) {
        $scopeConfig = \Magento\Framework\App\ObjectManager::getInstance()->get(\Magento\Framework\App\Config\ScopeConfigInterface::class);
        $storeScope = \Magento\Store\Model\ScopeInterface::SCOPE_STORE;
        $quivers_upc = $scopeConfig->getValue(self::XML_QUIVERS_UPC, $storeScope);
        if ($quivers_upc) {
            return  $product->getData($quivers_upc);
        }else {
            return  $product->getData('upc');
        }
    }
    public function getQuiversApiKey()
	{	
        $storeScope = \Magento\Store\Model\ScopeInterface::SCOPE_STORE;
		$key =$this->scopeConfig->getValue(self::XML_QUIVERS_API_KEY, $storeScope);
        return $key;
    }
    public function getQuiversRefId()
	{	
        $storeScope = \Magento\Store\Model\ScopeInterface::SCOPE_STORE;
		return $this->scopeConfig->getValue(self::XML_QUIVERS_REF_ID, $storeScope);
    }

	public function getSiteBaseUrl()
    {
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $storeManager = $objectManager->get('\Magento\Store\Model\StoreManagerInterface');
        return  $storeManager->getStore()->getBaseUrl();
    }
    public function getMagentoShippingEstimateUrl($id)
    {
        $storeScope = \Magento\Store\Model\ScopeInterface::SCOPE_STORE;
       return  $this->getSiteBaseUrl().'rest/'.$storeScope.'/V1/carts/'.$id.'/estimate-shipping-methods';
    }

	public function getMarketPlaceForCurrency() {
		$storeCurrency	=$this->getCurrentCurrencyCode();
        $scopeConfig = \Magento\Framework\App\ObjectManager::getInstance()->get(\Magento\Framework\App\Config\ScopeConfigInterface::class);
        $storeScope = \Magento\Store\Model\ScopeInterface::SCOPE_STORE;
        if($storeCurrency) {
            $marketPlaceId = null;
            switch (strtolower($storeCurrency)) {
                case 'usd':
                    $marketPlaceId = $scopeConfig->getValue(self::XML_USD_MARKETPLACE_ID, $storeScope);
                    break;
                case 'euro':
                    $marketPlaceId = $scopeConfig->getValue(self::XML_EURO_MARKETPLACE_ID, $storeScope);
                    break;
                case 'cad':
                    $marketPlaceId = $scopeConfig->getValue(self::XML_CAD_MARKETPLACE_ID, $storeScope);
                    break;
                case 'aud':
                    $marketPlaceId = $scopeConfig->getValue(self::XML_AUD_MARKETPLACE_ID, $storeScope);
                    break;
                case 'jpy':
                    $marketPlaceId = $scopeConfig->getValue(self::XML_JPY_MARKETPLACE_ID, $storeScope);
                    break;
                case 'gbp':
                    $marketPlaceId = $scopeConfig->getValue(self::XML_GBP_MARKETPLACE_ID, $storeScope);
                    break;
            }
            return $marketPlaceId;
        }
    }
    public function getCountryByWebsite()
    {
        $storeScope = \Magento\Store\Model\ScopeInterface::SCOPE_STORE;
		return $this->scopeConfig->getValue(self::COUNTRY_CODE_PATH, $storeScope);

    }

    public function getQuotedataToSetOrder()
    {
        $storeScope = \Magento\Store\Model\ScopeInterface::SCOPE_STORE;
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $checkoutsession = $objectManager->get('\Magento\Checkout\Model\Session');
        $total = $objectManager->get('\Magento\Quote\Model\Quote\Address\Total');
        $quote = $checkoutsession->getQuote();
        $items = $quote->getAllItems();
        $cartdata = [];

        foreach($items as $item){
            $itemData = $item->getData();
            if(array_key_exists('parent_item_id', $itemData) 
               && !is_null($itemData['parent_item_id'])) {
                continue;
            }
            $AdditionalData =$item->getBopisdata();
            $AdditionalData=json_decode($AdditionalData);
            $cartItems = [
                'uuid' => isset($AdditionalData->uuid)? $AdditionalData->uuid: null, 
                'id' => $item->getProductId() ,
                'qty'=>$item->getQty(),
                'businessRefId' => isset($AdditionalData->businessRefId)? $AdditionalData->businessRefId: null,
                'searchterm' => isset($AdditionalData->searchterm)? $AdditionalData->searchterm: null, 
                'curbsidepick' => isset($AdditionalData->curbsidepick)? $AdditionalData->curbsidepick: null, 
                'instorepickup' => isset($AdditionalData->instorepickup)? $AdditionalData->instorepickup: null

            ];
            array_push($cartdata,$cartItems);
            
        }
        return $cartdata;
    }

    Public function CallAPI($method, $url, $data = false, $headers = false, $timeout = 10)
	{
		$curl = curl_init();
		switch ($method)
		{
			case "POST":
				curl_setopt($curl, CURLOPT_POST, 1);
				// curl_setopt( $curl, CURLOPT_HTTPHEADER, array('Content-Type:application/json'));
				if ($data)
					curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
				break;
			case "PUT":
				curl_setopt($curl, CURLOPT_PUT, 1);
				break;
			default:
				if ($data)
					$url = sprintf("%s?%s", $url, http_build_query($data));
		}

		curl_setopt($curl, CURLOPT_URL, $url);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, $timeout - 1);
		curl_setopt($curl, CURLOPT_TIMEOUT, $timeout);
		if ($headers) {
			foreach ($headers as $header) {
				curl_setopt( $curl, CURLOPT_HTTPHEADER, $header);
			}
		}

		$res = [];
		try{
			$result = curl_exec($curl);
		}
		catch(Exception $e) {
			return $res;
		}

		$httpcode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
		$res['data'] = $result;
		$res['httpcode'] = @$httpcode;
		return $res;
	}

}
