<?php

namespace QuiversBopis\Integration\Model;

use Magento\Checkout\Model\ConfigProviderInterface;
use Magento\Framework\App\Config\ScopeConfigInterface;
use Magento\Shipping\Model\Config;
use QuiversBopis\Integration\Model;

class GetShippingMethod implements ConfigProviderInterface
{
    protected $scopeConfig;
    protected $shippingmodelconfig;  
    public $configProvider;
    protected $addressRepository;
    protected $quote;
    const XML_QUIVERS_UPC = 'quivers/parameters/quivers_custom_upc';
 
    public function __construct( \Magento\Directory\Model\Currency $currency,
    \QuiversBopis\Integration\Model\ConfigProvider $configProvider,
    \Magento\Customer\Api\AddressRepositoryInterface $addressRepository,
    \Magento\Checkout\Model\Session $checkoutSession,
     Config $shippingmodelconfig, ScopeConfigInterface $scopeConfig

    ){
        $this->shippingmodelconfig = $shippingmodelconfig;
        $this->scopeConfig = $scopeConfig;
        $this->quote = $checkoutSession->getQuote();
        $this->_currency = $currency;  
        $this->addressRepository= $addressRepository;
        $this->configProvider = $configProvider;

    }
    public function getConfig()
    {
        $config = [];
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $checkoutSession = $objectManager->get('Magento\Checkout\Model\Session');
        $config['bopis_status'] = $this->configProvider->getBopisStatus();
        $config['shipping_status'] = $checkoutSession->getQuiversShippingStatus();
        $config['mixed_method_title'] = $checkoutSession->getBopisMixedTitle();
        $config['methods'] = $checkoutSession->getAllShippingRates();
        return $config;
    }
    /**
     * Retrieve checkout configuration
     *
     * @return array
     * @codeCoverageIgnore
     */
    public function getShippingMethods($storeid) {
        $shipping_method = $this->quote->getShippingAddress()->getShippingMethod();
        $country = $this->configProvider->getCountryByWebsite();
        $shipping = [];
        $shippingRates = [];
        $QuiversshippingMethods = $this->configProvider->getShippingCarrier($storeid);
        return $QuiversshippingMethods;
        
         
   }
 /**
     * Retrieve checkout configuration
     *
     * @return array
     * @codeCoverageIgnore
     */
    public function getShippingAddress() {
        $address =[];
        $shippingaddress = $this
        ->quote
        ->getShippingAddress();
    $address['street'] =  $shippingaddress->getStreet();
    $address['company'] =  $shippingaddress->getCompany();
    $address['city'] =   $shippingaddress->getCity(); // Update city
    $address['postalCode'] =  $shippingaddress->getPostcode();
    $address['region'] = $shippingaddress->getRegion();
    $address['region_id'] = $shippingaddress->getRegionId();
    $address['country']= $shippingaddress->getCountryId();
           return $address;    
   }

}