<?php

namespace  QuiversBopis\Integration\Model;

use Magento\Store\Api\Data\StoreInterface;

class StoreSwitcher extends \Magento\Store\Model\StoreSwitcher
{
    const XML_ENABLED = 'quiversbopis/parameters/enable';

    public function switch(StoreInterface $fromStore, StoreInterface $targetStore, string $redirectUrl): string
    {
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $enable = $fromStore->getConfig(self::XML_ENABLED);
        $tostoreenable = $targetStore->getConfig(self::XML_ENABLED);
        $targetUrl = parent::switch($fromStore, $targetStore, $redirectUrl);
        if ($enable == "0" &&  $tostoreenable=="0"){
            return $targetUrl;
        }
        //empty cart while changing store 
         $this->deleteQuoteItems();
        return $targetUrl;
    }


    public function deleteQuoteItems(){

       $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
       $checkoutSession = $objectManager->get("Magento\Checkout\Model\Session");
       $checkoutSession->clearQuote();
       $checkoutSession->clearStorage();
       $checkoutSession->restoreQuote();
    }
        
}
