<?php
namespace QuiversBopis\Integration\Observer;

use Magento\Framework\Event\ObserverInterface;
use Magento\Framework\App\Response\RedirectInterface;
use Magento\Checkout\Model\Cart;
use Magento\Framework\Message\ManagerInterface;
use Magento\Framework\App\RequestInterface;
use Magento\Catalog\Model\Product;
use  QuiversBopis\Integration\Model\ConfigProvider;
use Magento\Framework\App\Http\Context as customerSession;
use QuiversBopis\Integration\LogTracking;

class CartAddRestric implements ObserverInterface
{
    protected $cart;
    protected $messageManager;
    protected $redirect;
    protected $request;
    protected $product;
    protected $customerSession;
    protected $configProvider;
    protected $log;
    public function __construct(LogTracking $log ,RedirectInterface $redirect,ConfigProvider $configProvider, Cart $cart, ManagerInterface $messageManager, RequestInterface $request, Product $product, customerSession $session)
    {
        $this->redirect = $redirect;
        $this->cart = $cart;
        $this->messageManager = $messageManager;
        $this->request = $request;
        $this->product = $product;
        $this->configProvider = $configProvider;
        $this->customerSession = $session;
        $this->log = $log;
    }
    public function execute(\Magento\Framework\Event\Observer $observer)
    {

        if(!$this->configProvider->getBopisStatus()){
            return true;
        }
        $postValues = $this
            ->request
            ->getPostValue();
        if($postValues['searchterm']=='null'){
            $observer->getRequest()->setParam('product', false);
        $this
            ->messageManager
            ->addErrorMessage(__('Something went Wrong '.$this->configProvider->errormessagedefault));

        }       
    }

}

