<?php
 
namespace QuiversBopis\Integration\Plugin;
 
use Magento\Framework\Exception\LocalizedException;
use Magento\Checkout\Model\Cart;


 
class BeforeCartPlugin
{
    /**
     * @var \Magento\Quote\Model\Quote
     */
    protected $quote;

    protected $request;

    protected $resultJsonFactory;

    protected $messageManager;
 
    /**
     * Plugin constructor.
     *
     * @param \Magento\Checkout\Model\Session $checkoutSession
     */
    public function __construct(
        \Magento\Checkout\Model\Session $checkoutSession,
        \Magento\Framework\App\Request\Http $request  ,
        \Magento\Framework\Controller\Result\JsonFactory $resultJsonFactory  ,
        \Magento\Framework\Message\ManagerInterface $messageManager    
    ) {
        $this->quote = $checkoutSession->getQuote();
        $this->request = $request;  
        $this->resultJsonFactory = $resultJsonFactory;  
        $this->messageManager = $messageManager;    
    }
 
    /**
     * afterAddProduct
     *
     * @param      $subject
     * @param      $result    Returned value from core observed method 'addProduct'     
     */
    public function beforeAddProduct(Cart $subject, $productInfo, $requestInfo = null)
{
           
            if(!$this->quote->getId()) {
                $token = openssl_random_pseudo_bytes(16);
                $uuid = bin2hex($token);
                $_SESSION['UUID'] = $uuid;
                $_SESSION['cart-items']=null;
            }
            
    }  
   
}
?>