<?php
namespace QuiversBopis\Integration\Plugin\Quote\Api;

use Magento\Quote\Api\ShippingMethodManagementInterface;

class ShippingMethodManagementPlugin
{
    protected $quote;
    public $configProvider;

    public function __construct(\Magento\Customer\Model\Session $customerSession,
    \QuiversBopis\Integration\Model\ConfigProvider $configProvider,
     \Magento\Checkout\Model\Session $checkoutSession)
    {
        $this->customerSession = $customerSession;
        $this->configProvider = $configProvider; 
        $this->quote = $checkoutSession->getQuote();
    }

    public function aroundEstimateByAddressId(ShippingMethodManagementInterface $subject,
     \Closure $proceed, $cartId, $addressId)
    {
        $shippingMethods = $proceed($cartId, $addressId);

        $methods =[];
        $bopismixed =$this->configProvider->bopismixed;
        $storepickupcode =$this->configProvider->storepickupcode;
        $bopistatus =$this->configProvider->getBopisStatus();
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $checkoutSession = $objectManager->get('Magento\Checkout\Model\Session');
        $shippingstatus = $checkoutSession->getQuiversShippingStatus();
        $bopisStatusCode = $this->configProvider->bopisStatusCode;
        $shippingSatusCode = $this->configProvider->shippingSatusCode;
        $mixedStatusCode =  $this->configProvider->mixedStatusCode;
    
        // if ($this->customerSession->isLoggedIn()) {
        foreach ($shippingMethods as $key => $shippingMethod)
        {
            if($bopistatus == true){
                if($shippingstatus== $mixedStatusCode && $shippingMethod->getMethodCode() == $bopismixed){
                    array_push($methods,$shippingMethods[$key]);
                }
                else if ($shippingstatus == $bopisStatusCode && $shippingMethod->getMethodCode() == $storepickupcode)
                {
                    array_push($methods,$shippingMethods[$key]);
                }
                else
                {
                    if ($shippingstatus == $shippingSatusCode && $shippingMethod->getMethodCode() != $bopismixed && $shippingMethod->getMethodCode() != $storepickupcode)
                        {
                            array_push($methods,$shippingMethods[$key]);
                        }  
                    }
                }
            else{
                if ($shippingMethod->getMethodCode() != $bopismixed && $shippingMethod->getMethodCode() != $storepickupcode)
                {
                    array_push($methods,$shippingMethods[$key]);
                }   
            }
            
        }
        return $methods;
    
        
    }
}

