<?php

namespace QuiversBopis\Integration\Plugin;

use Magento\Checkout\Block\Checkout\LayoutProcessor;
use QuiversBopis\Integration\Model\ConfigProvider;
/**
 * Class SidebarDisable
 *
 * @package Vendorname\SidebarActivation\Plugin
 */
class SidebarContentDisable {

    public $configProvider;
 
    public function __construct(
    ConfigProvider $configProvider){
        $this->configProvider = $configProvider; 
    }
    /**
     * @param \Magento\Checkout\Block\Checkout\LayoutProcessor $processor
     * @param array $jsLayout
     *
     * @return array
     */
    public function afterProcess(
        LayoutProcessor $processor,
        array $jsLayout
    ){

        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $configProvider = $objectManager->get("\QuiversBopis\Integration\Model\ConfigProvider");
        $checkoutSession = $objectManager->get('Magento\Checkout\Model\Session');
        $enable = $configProvider->getBopisStatus();

        $shippingstatus = $checkoutSession->getQuiversShippingStatus();
        if($enable && isset($shippingstatus) && ($shippingstatus == $configProvider->mixedStatusCode || $shippingstatus == $configProvider->bopisStatusCode)){
            unset($jsLayout['components']['checkout']['children']['sidebar']['children']['shipping-information']);
        }
   

        return $jsLayout;
    }
}