<?php
namespace QuiversBopis\Integration\Setup;

use Magento\Framework\Setup\InstallSchemaInterface;
use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\Setup\SchemaSetupInterface;
class InstallSchema implements InstallSchemaInterface
{

/**
 * {@inheritdoc}
 * @SuppressWarnings(PHPMD.ExcessiveMethodLength)
 */
public function install(SchemaSetupInterface $setup, ModuleContextInterface    $context)
  {
    $installer = $setup;
    $installer->startSetup();

    $eavTable = $installer->getTable('quote_item');

    $columns = [
        'bopisdata' => [
            'type' => \Magento\Framework\DB\Ddl\Table::TYPE_BLOB,
            'nullable' => false,
            'comment' => 'bopisdata',
        ],
    
        'bopis_shippingcode' => [
            'type' => \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
            'nullable' => false,
            'comment' => 'shipping code',
    
        ],

       'bopis_shippingfee' => [
        'type' => \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
        'nullable' => false,
        'comment' => 'shipping fee',
        ]
    ];

     
    $connection = $installer->getConnection();
    foreach ($columns as $name => $definition) {
        $connection->addColumn($eavTable, $name, $definition);
    }

    $installer->endSetup();
}
}

