/**
 * Copyright © Magento, Inc. All rights reserved.
 * See COPYING.txt for license details.
 */

 define([
    'uiComponent'
], function (Component) {
    'use strict';
    return Component.extend({
        defaults: {
            template: 'Magento_Checkout/summary/item/details'
        },

        /**
         * @param {Object} quoteItem
         * @return {String}
         */
        getValue: function (quoteItem) {
            return quoteItem.name;
        },

        getItemStatus: function (itemId) {
            var bopisactive = 0;
            if(document.getElementById("bopisstatus")){
                bopisactive = document.getElementById("bopisstatus").value;
            }
            if(bopisactive == 0){
                return "";
            }

            var itemsData = window.checkoutConfig.quoteItemData;
            var bopisstatus = "";
            itemsData.forEach(function(item) {
                if (item.item_id == itemId) {
                    var  additionaldta = item.bopisdata;
                    if (additionaldta == ""){
                        bopisstatus = "";
                    }
                    else{
                        additionaldta =JSON.parse(additionaldta);
                        if(additionaldta.instorepickup && additionaldta.instorepickup==true){
                            bopisstatus = "In store pick up at "+ additionaldta.businessName;
                            }
                        if(additionaldta.curbsidepick && additionaldta.curbsidepick==true){
                            bopisstatus= 'Curbside pick up at '+ additionaldta.businessName;
                        }    
                    } 
                }
            });
         return bopisstatus;
        }

    });
});